//
//  ViewController.m
//  HelloSocial
//
//  Created by Victor Chandra on 11/7/12.
//  Copyright (c) 2012 Victor Chandra. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize arrayDataSource;

-(IBAction)activityViewController:(id)sender
{
    NSString *caption = @"Sedang belajar...";
    UIImage *image = [UIImage imageNamed:@"fry.jpg"];
    NSURL *url = [NSURL URLWithString:
                  @"http://www.victorchandra.com"];
    
    NSArray *activityItems = @[image, caption, url];
    //NSArray *activityItems = [NSArray arrayWithObjects:image, caption, url, nil];
    
    // Siapkan Activity View Controller
    UIActivityViewController *vc =
    [[UIActivityViewController alloc]
     initWithActivityItems:activityItems
     applicationActivities:nil];
    
    vc.excludedActivityTypes =
    @[UIActivityTypeSaveToCameraRoll, UIActivityTypePrint];

    // Tampilkan Activity View Controller
    [self presentViewController:vc
                       animated:YES
                     completion:nil];
}

-(IBAction)facebookUpdateStatus:(id)sender
{
    if ([SLComposeViewController
         isAvailableForServiceType:SLServiceTypeFacebook])
    {
        SLComposeViewController *facebook =
        [SLComposeViewController
         composeViewControllerForServiceType:SLServiceTypeFacebook];
        
        [facebook setInitialText:@"Sedang belajar..."];
        
        [facebook addImage:[UIImage imageNamed:@"fry.jpg"]];
        
        [self presentViewController:facebook
                           animated:TRUE
                         completion:nil];
    }
}

-(IBAction)twitterPostTweet:(id)sender
{
    if ([SLComposeViewController
         isAvailableForServiceType:SLServiceTypeTwitter])
    {
        SLComposeViewController *twitter =
        [SLComposeViewController
         composeViewControllerForServiceType:SLServiceTypeTwitter];
        
        [twitter setInitialText:@"Sedang belajar..."];
        
        [twitter addImage:[UIImage imageNamed:@"fry.jpg"]];
        
        [self presentViewController:twitter
                           animated:TRUE
                         completion:nil];
    }
}

-(IBAction)twitterRequestTimeline:(id)sender
{    
    ACAccountStore *account = [[ACAccountStore alloc] init];
    ACAccountType *accountType = [account
                                  accountTypeWithAccountTypeIdentifier:
                                  ACAccountTypeIdentifierTwitter];
    [account requestAccessToAccountsWithType:accountType
                                     options:nil
                                  completion:^(BOOL granted, NSError *error)
     {
         if (granted == YES)
         {
             NSArray *arrayOfAccounts = [account
                                         accountsWithAccountType:accountType];
             if ([arrayOfAccounts count] > 0)
             {
                 ACAccount *twitterAccount =
                 [arrayOfAccounts objectAtIndex:0];
                 
                 NSURL *requestURL = [NSURL
                                      URLWithString:
                    @"http://api.twitter.com/1.1/statuses/home_timeline.json"];

                 NSMutableDictionary *parameters = [[NSMutableDictionary
                                                     alloc] init];
                 [parameters setObject:@"10" forKey:@"count"];
             
                 SLRequest *postRequest = [SLRequest
                                    requestForServiceType:SLServiceTypeTwitter
                                            requestMethod:SLRequestMethodGET
                                                      URL:requestURL
                                               parameters:parameters];
                 postRequest.account = twitterAccount;
                 
                 [postRequest performRequestWithHandler:
                  ^(NSData *responseData,
                    NSHTTPURLResponse *urlResponse,
                    NSError *error)
                  {
                      arrayDataSource = [NSJSONSerialization
                                JSONObjectWithData:responseData
                                           options:NSJSONReadingMutableLeaves
                                             error:&error];
                      namaTable = @"Timeline";
                      [outletTableView
                       performSelectorOnMainThread:@selector(reloadData)
                                        withObject:nil
                                     waitUntilDone:TRUE];
                  }];
             }
         } else {
            UIAlertView *alert = [[UIAlertView alloc]
                                  initWithTitle:@"Maaf"
                                        message:@"Akses tidak diijinkan"
                                       delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
             
             [alert performSelectorOnMainThread:@selector(show)
                                     withObject:nil
                                  waitUntilDone:TRUE];
         }
     }];
}

-(IBAction)twitterRequestMentions:(id)sender
{
    ACAccountStore *account = [[ACAccountStore alloc] init];
    ACAccountType *accountType = [account accountTypeWithAccountTypeIdentifier:ACAccountTypeIdentifierTwitter];
    
    [account requestAccessToAccountsWithType:accountType
                                     options:nil
                                  completion:^(BOOL granted, NSError *error)
     {
         if (granted == YES)
         {
             NSArray *arrayOfAccounts = [account accountsWithAccountType:accountType];
             
             if ([arrayOfAccounts count] > 0)
             {
                 ACAccount *twitterAccount = [arrayOfAccounts objectAtIndex:0];
                 NSURL *requestURL = [NSURL URLWithString:@"http://api.twitter.com/1.1/statuses/mentions_timeline.json"];
                 
                 NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
                 [parameters setObject:@"10" forKey:@"count"];
                 
                 SLRequest *postRequest = [SLRequest requestForServiceType:SLServiceTypeTwitter
                                                             requestMethod:SLRequestMethodGET
                                                                       URL:requestURL
                                                                parameters:parameters];
                 postRequest.account = twitterAccount;
                 
                 [postRequest performRequestWithHandler:
                  ^(NSData *responseData, NSHTTPURLResponse *urlResponse, NSError *error)
                  {
                      arrayDataSource = [NSJSONSerialization JSONObjectWithData:responseData
                                                                        options:NSJSONReadingMutableLeaves
                                                                          error:&error];
                      namaTable = @"Mentions";
                      [outletTableView performSelectorOnMainThread:@selector(reloadData) withObject:nil waitUntilDone:TRUE];
                  }];
             }
         } else {
             // gagal mendapatkan ijin access
             UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Maaf"
                                                             message:@"Akses tidak diijinkan"
                                                            delegate:nil
                                                   cancelButtonTitle:@"OK"
                                                   otherButtonTitles:nil];
             [alert performSelectorOnMainThread:@selector(show) withObject:nil waitUntilDone:TRUE];
         }
     }];
}


#pragma mark - UITableViewDelegate

- (NSInteger)tableView:(UITableView *)tableView
 numberOfRowsInSection:(NSInteger)section
{
    return [arrayDataSource count];
}

- (NSString *)tableView:(UITableView *)tableView
titleForHeaderInSection:(NSInteger)section
{
    return namaTable;
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView
        dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]
                initWithStyle:UITableViewCellStyleSubtitle
              reuseIdentifier:CellIdentifier];
    }
    
    // Configure the cell...
    [cell.textLabel setText:
     [[arrayDataSource objectAtIndex:indexPath.row]
      objectForKey:@"text"]];
    
    [cell.detailTextLabel setText:
     [[[arrayDataSource objectAtIndex:indexPath.row]
       objectForKey:@"user"] objectForKey:@"name"]];
    
    return cell;
}

#pragma mark - UITableViewDataSource

- (void)tableView:(UITableView *)tableView
didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *username = [[[arrayDataSource objectAtIndex:indexPath.row]
                           objectForKey:@"user"] objectForKey:@"name"];
    NSString *tweet = [[arrayDataSource objectAtIndex:indexPath.row]
                       objectForKey:@"text"];
    
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:username
                                                    message:tweet
                                                   delegate:nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil];
    [alert show];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
